<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CapabilityAgents/TemplateRuntime/include/TemplateRuntime/TemplateRuntime.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_ad7482f55cfb335a38f864aa77f75e62.html">TemplateRuntime</a></li><li class="navelem"><a class="el" href="dir_c812ba13d40d97c773fd9f77093be04d.html">include</a></li><li class="navelem"><a class="el" href="dir_029029bde7d05d489ea7e2dc05d6ef88.html">TemplateRuntime</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">TemplateRuntime.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_template_runtime_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CAPABILITYAGENTS_TEMPLATERUNTIME_INCLUDE_TEMPLATERUNTIME_TEMPLATERUNTIME_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CAPABILITYAGENTS_TEMPLATERUNTIME_INCLUDE_TEMPLATERUNTIME_TEMPLATERUNTIME_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;queue&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;unordered_set&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_capability_agent_8h.html">AVSCommon/AVS/CapabilityAgent.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_capability_configuration_8h.html">AVSCommon/AVS/CapabilityConfiguration.h</a>&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_capability_configuration_interface_8h.html">AVSCommon/SDKInterfaces/CapabilityConfigurationInterface.h</a>&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_audio_player_interface_8h.html">AVSCommon/SDKInterfaces/AudioPlayerInterface.h</a>&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_audio_player_observer_interface_8h.html">AVSCommon/SDKInterfaces/AudioPlayerObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_dialog_u_x_state_observer_interface_8h.html">AVSCommon/SDKInterfaces/DialogUXStateObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_focus_manager_interface_8h.html">AVSCommon/SDKInterfaces/FocusManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_template_runtime_observer_interface_8h.html">AVSCommon/SDKInterfaces/TemplateRuntimeObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_requires_shutdown_8h.html">AVSCommon/Utils/RequiresShutdown.h</a>&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_executor_8h.html">AVSCommon/Utils/Threading/Executor.h</a>&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_a_v_s_common_2_utils_2include_2_a_v_s_common_2_utils_2_timing_2_timer_8h.html">AVSCommon/Utils/Timing/Timer.h</a>&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">namespace </span>capabilityAgents {</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1template_runtime.html">   39</a></span>&#160;<span class="keyword">namespace </span>templateRuntime {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html">   54</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html">TemplateRuntime</a></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">avsCommon::avs::CapabilityAgent</a></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">avsCommon::utils::RequiresShutdown</a></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface.html">avsCommon::sdkInterfaces::AudioPlayerObserverInterface</a></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_dialog_u_x_state_observer_interface.html">avsCommon::sdkInterfaces::DialogUXStateObserverInterface</a></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        , <span class="keyword">public</span> std::enable_shared_from_this&lt;TemplateRuntime&gt; {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;TemplateRuntime&gt; <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a4df4e8af2c49e6e12b9103dddafe06fb">create</a>(</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::AudioPlayerInterface&gt; audioPlayerInterface,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::FocusManagerInterface&gt; focusManager,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionSender);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ad56e4a644e8335ffdace8a2a1d43f3e2">~TemplateRuntime</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a3b201a2afa5e3d9b8f02ced732b929a3">handleDirectiveImmediately</a>(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive) <span class="keyword">override</span>;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a99e7dfaba76a15aa5f37de340e155e65">preHandleDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) <span class="keyword">override</span>;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a5a5eac6267134c3fa261ae145115a37b">handleDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) <span class="keyword">override</span>;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a947fa2c32902652d5931146712174fc2">cancelDirective</a>(std::shared_ptr&lt;DirectiveInfo&gt; info) <span class="keyword">override</span>;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avsCommon::avs::DirectiveHandlerConfiguration</a> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a36a63eab9d6b4b9245ba9fef64e0535b">getConfiguration</a>() <span class="keyword">const override</span>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a668e0e4648bf40aef21cf7206f9e12fd">onFocusChanged</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">avsCommon::avs::FocusState</a> newFocus) <span class="keyword">override</span>;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a823c3a7e76f61972122d8639b3e3c7d1">onPlayerActivityChanged</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47b">avsCommon::avs::PlayerActivity</a> state, <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface_1_1_context.html">Context</a>&amp; context) <span class="keyword">override</span>;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a64f9cc33586731f92698b36b5ca61dea">onDialogUXStateChanged</a>(</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_dialog_u_x_state_observer_interface.html#a728a1ce41f6997d23f740e452dc5e066">avsCommon::sdkInterfaces::DialogUXStateObserverInterface::DialogUXState</a> newState) <span class="keyword">override</span>;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ac6715180de2a75388a6d877ff55b17c2">addObserver</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface&gt; observer);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a37d1c777164f9f8dd86b7ef3abdcb657">removeObserver</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface&gt; observer);</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ad39d5e92ce608efc5104e5e5cc9e60bc">displayCardCleared</a>();</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;avsCommon::avs::CapabilityConfiguration&gt;&gt; <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ad5c58ee8abfedd9f9da7cb488b4fc76b">getCapabilityConfigurations</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keyword">enum class</span> State {</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47baa5daf7f2ebbba4975d61dab1c40188c7">IDLE</a>,</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="comment">/*</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">         * The @c TemplateRuntime has received a displayCard event is acquiring the visual channel from @c</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">         * FocusManager.</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">         */</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        ACQUIRING,</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="comment">/*</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment">         * The @c TemplateRuntime has focus, either background or foreground, of the channel and has</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="comment">         * notified its observers of a displayCard.  @TemplateRuntime will remain in this state until there is a</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="comment">         * timeout, clearCard, or focusChanged(NONE) event.</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="comment">         */</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        DISPLAYING,</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="comment">/*</span></div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment">         * The @c TemplateRuntime has received a timeout or a clearCard event and is releasing the</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment">         * channel and has notified its observers to clear the display.</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">         */</span></div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        RELEASING,</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="comment">/*</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="comment">         * The @c TemplateRuntime has received a displayCard event during releasing of the channel and is trying to</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="comment">         * acquire the visual channel again.</span></div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="comment">         */</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;        REACQUIRING</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    };</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    <span class="keyword">struct </span>AudioItemPair {</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        AudioItemPair() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        AudioItemPair(</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            std::string itemId,</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;            std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo&gt; renderPlayerInfoDirective) :</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                audioItemId{itemId},</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;                directive{renderPlayerInfoDirective} {};</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        std::string audioItemId;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo&gt; directive;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    };</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html">TemplateRuntime</a>(</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::AudioPlayerInterface&gt; audioPlayerInterface,</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::FocusManagerInterface&gt; focusManager,</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionSender);</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="comment">// @name RequiresShutdown Functions</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> doShutdown() <span class="keyword">override</span>;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordtype">bool</span> initialize();</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <span class="keywordtype">void</span> removeDirective(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordtype">void</span> setHandlingCompleted(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="keywordtype">void</span> handleRenderTemplateDirective(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <span class="keywordtype">void</span> handleRenderPlayerInfoDirective(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keywordtype">void</span> handleUnknownDirective(std::shared_ptr&lt;DirectiveInfo&gt; info);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    <span class="keywordtype">void</span> executeAudioPlayerInfoUpdates(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47b">avsCommon::avs::PlayerActivity</a> state, <span class="keyword">const</span> <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface_1_1_context.html">Context</a>&amp; context);</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <span class="keywordtype">void</span> executeAudioPlayerStartTimer(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47b">avsCommon::avs::PlayerActivity</a> state);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keywordtype">void</span> executeRenderPlayerInfoCallbacks(<span class="keywordtype">bool</span> isClearCard);</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    <span class="keywordtype">void</span> executeRenderTemplateCallbacks(<span class="keywordtype">bool</span> isClearCard);</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="keywordtype">void</span> executeDisplayCard();</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keywordtype">void</span> executeClearCard();</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="keywordtype">void</span> executeStartTimer(std::chrono::milliseconds timeout);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    <span class="keywordtype">void</span> executeStopTimer();</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    std::string stateToString(<span class="keyword">const</span> TemplateRuntime::State state);</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    <span class="keywordtype">void</span> executeTimerEvent();</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keywordtype">void</span> executeOnFocusChangedEvent(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">avsCommon::avs::FocusState</a> newFocus);</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="keywordtype">void</span> executeDisplayCardEvent(</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        <span class="keyword">const</span> std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo&gt; info);</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    <span class="keywordtype">void</span> executeCardClearedEvent();</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">avsCommon::utils::timing::Timer</a> m_clearDisplayTimer;</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface&gt;&gt; m_observers;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;<span class="comment">     * This is used to store the current executing @c AudioItem based on the callbacks from the</span></div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;<span class="comment">     * AudioPlayerObserverInterface.</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    AudioItemPair m_audioItemInExecution;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;<span class="comment">     * This queue is for storing the @c RenderPlayerInfo directives when its audioItemId does not match the audioItemId</span></div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;<span class="comment">     * in execution in the @c AudioPlayer.</span></div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    std::queue&lt;AudioItemPair&gt; m_audioItems;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_template_runtime_observer_interface_1_1_audio_player_info.html">avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface::AudioPlayerInfo</a> m_audioPlayerInfo;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    std::shared_ptr&lt;alexaClientSDK::avsCommon::avs::CapabilityAgent::DirectiveInfo&gt; m_lastDisplayedDirective;</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="keywordtype">bool</span> m_isRenderTemplateLastReceived;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">avsCommon::avs::FocusState</a> m_focus;</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    State m_state;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;<span class="comment">     * This is an interface to the @c AudioPlayer.  The @c TemplateRuntime CA used this interface to add and remove</span></div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;<span class="comment">     * itself as an observer to the @c AudioPlayer.  The interface is also used to query the latest offset of the audio</span></div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;<span class="comment">     * playback in the @c AudioPlayer.</span></div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::AudioPlayerInterface&gt; m_audioPlayerInterface;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::FocusManagerInterface&gt; m_focusManager;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;avsCommon::avs::CapabilityConfiguration&gt;&gt; m_capabilityConfigurations;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">avsCommon::utils::threading::Executor</a> m_executor;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;    std::chrono::milliseconds m_ttsFinishedTimeout;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    std::chrono::milliseconds m_audioPlaybackFinishedTimeout;</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    std::chrono::milliseconds m_audioPlaybackStoppedPausedTimeout;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;};</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;}  <span class="comment">// namespace templateRuntime</span></div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;}  <span class="comment">// namespace capabilityAgents</span></div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CAPABILITYAGENTS_TEMPLATERUNTIME_INCLUDE_TEMPLATERUNTIME_TEMPLATERUNTIME_H_</span></div><div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_template_runtime_observer_interface_1_1_audio_player_info_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_template_runtime_observer_interface_1_1_audio_player_info.html">alexaClientSDK::avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface::AudioPlayerInfo</a></div><div class="ttdef"><b>Definition:</b> TemplateRuntimeObserverInterface.h:40</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html">alexaClientSDK::avsCommon::avs::CapabilityAgent</a></div><div class="ttdef"><b>Definition:</b> CapabilityAgent.h:47</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a36a63eab9d6b4b9245ba9fef64e0535b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a36a63eab9d6b4b9245ba9fef64e0535b">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::getConfiguration</a></div><div class="ttdeci">avsCommon::avs::DirectiveHandlerConfiguration getConfiguration() const override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:185</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_capability_configuration_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::CapabilityConfigurationInterface</a></div><div class="ttdef"><b>Definition:</b> CapabilityConfigurationInterface.h:32</div></div>
<div class="ttc" id="_template_runtime_observer_interface_8h_html"><div class="ttname"><a href="_template_runtime_observer_interface_8h.html">TemplateRuntimeObserverInterface.h</a></div></div>
<div class="ttc" id="_capability_agent_8h_html"><div class="ttname"><a href="_capability_agent_8h.html">CapabilityAgent.h</a></div></div>
<div class="ttc" id="_a_v_s_common_2_utils_2include_2_a_v_s_common_2_utils_2_timing_2_timer_8h_html"><div class="ttname"><a href="_a_v_s_common_2_utils_2include_2_a_v_s_common_2_utils_2_timing_2_timer_8h.html">Timer.h</a></div></div>
<div class="ttc" id="_requires_shutdown_8h_html"><div class="ttname"><a href="_requires_shutdown_8h.html">RequiresShutdown.h</a></div></div>
<div class="ttc" id="_audio_player_observer_interface_8h_html"><div class="ttname"><a href="_audio_player_observer_interface_8h.html">AudioPlayerObserverInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1threading_1_1_executor.html">alexaClientSDK::avsCommon::utils::threading::Executor</a></div><div class="ttdef"><b>Definition:</b> Executor.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a64f9cc33586731f92698b36b5ca61dea"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a64f9cc33586731f92698b36b5ca61dea">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::onDialogUXStateChanged</a></div><div class="ttdeci">void onDialogUXStateChanged(avsCommon::sdkInterfaces::DialogUXStateObserverInterface::DialogUXState newState) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:207</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_ad5c58ee8abfedd9f9da7cb488b4fc76b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ad5c58ee8abfedd9f9da7cb488b4fc76b">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::getCapabilityConfigurations</a></div><div class="ttdeci">std::unordered_set&lt; std::shared_ptr&lt; avsCommon::avs::CapabilityConfiguration &gt; &gt; getCapabilityConfigurations() override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:747</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_af150b2d10515e0e7347e09a69986a47baa5daf7f2ebbba4975d61dab1c40188c7"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47baa5daf7f2ebbba4975d61dab1c40188c7">alexaClientSDK::avsCommon::avs::PlayerActivity::IDLE</a></div><div class="ttdoc">Initial state, prior to acting on the first Play directive. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a4df4e8af2c49e6e12b9103dddafe06fb"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a4df4e8af2c49e6e12b9103dddafe06fb">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::create</a></div><div class="ttdeci">static std::shared_ptr&lt; TemplateRuntime &gt; create(std::shared_ptr&lt; avsCommon::sdkInterfaces::AudioPlayerInterface &gt; audioPlayerInterface, std::shared_ptr&lt; avsCommon::sdkInterfaces::FocusManagerInterface &gt; focusManager, std::shared_ptr&lt; avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface &gt; exceptionSender)</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:104</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></div><div class="ttdef"><b>Definition:</b> RequiresShutdown.h:32</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a947fa2c32902652d5931146712174fc2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a947fa2c32902652d5931146712174fc2">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::cancelDirective</a></div><div class="ttdeci">void cancelDirective(std::shared_ptr&lt; DirectiveInfo &gt; info) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:181</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a2c1f3500cf37d70ffd6c1067f9c7f921"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">alexaClientSDK::avsCommon::avs::DirectiveHandlerConfiguration</a></div><div class="ttdeci">std::unordered_map&lt; NamespaceAndName, BlockingPolicy &gt; DirectiveHandlerConfiguration</div><div class="ttdef"><b>Definition:</b> DirectiveHandlerConfiguration.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a066217aef6bc1e0e18dd3a13f467d275"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a066217aef6bc1e0e18dd3a13f467d275">alexaClientSDK::avsCommon::avs::FocusState</a></div><div class="ttdeci">FocusState</div><div class="ttdef"><b>Definition:</b> FocusState.h:28</div></div>
<div class="ttc" id="_focus_manager_interface_8h_html"><div class="ttname"><a href="_focus_manager_interface_8h.html">FocusManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::AudioPlayerObserverInterface</a></div><div class="ttdef"><b>Definition:</b> AudioPlayerObserverInterface.h:31</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_dialog_u_x_state_observer_interface_html_a728a1ce41f6997d23f740e452dc5e066"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_dialog_u_x_state_observer_interface.html#a728a1ce41f6997d23f740e452dc5e066">alexaClientSDK::avsCommon::sdkInterfaces::DialogUXStateObserverInterface::DialogUXState</a></div><div class="ttdeci">DialogUXState</div><div class="ttdoc">The different dialog specific AVS UX states. </div><div class="ttdef"><b>Definition:</b> DialogUXStateObserverInterface.h:32</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a3b201a2afa5e3d9b8f02ced732b929a3"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a3b201a2afa5e3d9b8f02ced732b929a3">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::handleDirectiveImmediately</a></div><div class="ttdeci">void handleDirectiveImmediately(std::shared_ptr&lt; avsCommon::avs::AVSDirective &gt; directive) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:156</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_ad56e4a644e8335ffdace8a2a1d43f3e2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ad56e4a644e8335ffdace8a2a1d43f3e2">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::~TemplateRuntime</a></div><div class="ttdeci">virtual ~TemplateRuntime()=default</div></div>
<div class="ttc" id="_executor_8h_html"><div class="ttname"><a href="_executor_8h.html">Executor.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">alexaClientSDK::avsCommon::utils::timing::Timer</a></div><div class="ttdef"><b>Definition:</b> Timer.h:36</div></div>
<div class="ttc" id="_capability_configuration_8h_html"><div class="ttname"><a href="_capability_configuration_8h.html">CapabilityConfiguration.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_audio_player_interface_8h_html"><div class="ttname"><a href="_audio_player_interface_8h.html">AudioPlayerInterface.h</a></div></div>
<div class="ttc" id="_capability_configuration_interface_8h_html"><div class="ttname"><a href="_capability_configuration_interface_8h.html">CapabilityConfigurationInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime</a></div><div class="ttdef"><b>Definition:</b> TemplateRuntime.h:54</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface_1_1_context_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_audio_player_observer_interface_1_1_context.html">alexaClientSDK::avsCommon::sdkInterfaces::AudioPlayerObserverInterface::Context</a></div><div class="ttdoc">The context of the AudioPlayer when the observer is notified of the PlayerActivity state change...</div><div class="ttdef"><b>Definition:</b> AudioPlayerObserverInterface.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a37d1c777164f9f8dd86b7ef3abdcb657"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a37d1c777164f9f8dd86b7ef3abdcb657">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::removeObserver</a></div><div class="ttdeci">void removeObserver(std::shared_ptr&lt; avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface &gt; observer)</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:239</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_ad39d5e92ce608efc5104e5e5cc9e60bc"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ad39d5e92ce608efc5104e5e5cc9e60bc">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::displayCardCleared</a></div><div class="ttdeci">void displayCardCleared()</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:295</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a99e7dfaba76a15aa5f37de340e155e65"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a99e7dfaba76a15aa5f37de340e155e65">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::preHandleDirective</a></div><div class="ttdeci">void preHandleDirective(std::shared_ptr&lt; DirectiveInfo &gt; info) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:161</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a823c3a7e76f61972122d8639b3e3c7d1"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a823c3a7e76f61972122d8639b3e3c7d1">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::onPlayerActivityChanged</a></div><div class="ttdeci">void onPlayerActivityChanged(avsCommon::avs::PlayerActivity state, const Context &amp;context) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:199</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_af150b2d10515e0e7347e09a69986a47b"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47b">alexaClientSDK::avsCommon::avs::PlayerActivity</a></div><div class="ttdeci">PlayerActivity</div><div class="ttdoc">Identifies the player state. </div><div class="ttdef"><b>Definition:</b> PlayerActivity.h:26</div></div>
<div class="ttc" id="_dialog_u_x_state_observer_interface_8h_html"><div class="ttname"><a href="_dialog_u_x_state_observer_interface_8h.html">DialogUXStateObserverInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_ac6715180de2a75388a6d877ff55b17c2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#ac6715180de2a75388a6d877ff55b17c2">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::addObserver</a></div><div class="ttdeci">void addObserver(std::shared_ptr&lt; avsCommon::sdkInterfaces::TemplateRuntimeObserverInterface &gt; observer)</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:224</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a668e0e4648bf40aef21cf7206f9e12fd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a668e0e4648bf40aef21cf7206f9e12fd">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::onFocusChanged</a></div><div class="ttdeci">void onFocusChanged(avsCommon::avs::FocusState newFocus) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:195</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime_html_a5a5eac6267134c3fa261ae145115a37b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a5a5eac6267134c3fa261ae145115a37b">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime::handleDirective</a></div><div class="ttdeci">void handleDirective(std::shared_ptr&lt; DirectiveInfo &gt; info) override</div><div class="ttdef"><b>Definition:</b> TemplateRuntime.cpp:166</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_dialog_u_x_state_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_dialog_u_x_state_observer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::DialogUXStateObserverInterface</a></div><div class="ttdoc">A dialog specific UX state observer. </div><div class="ttdef"><b>Definition:</b> DialogUXStateObserverInterface.h:29</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
